        MAX_Z  EQU  180
        MIN_Z  EQU  50

LOCALS  @@
code    segment
        assume cs:code
        org    100h
@@1:    jmp    @@2

        data   label byte
        include toxic.inc
        info   db 'TOXIC - (c) MATI Inc. 1999',13,10,36
        logodata label byte
        include matilogo.inc
        toxilogo label byte
        include toxilogo.inc
        datelogo label byte
        include date.inc
        c      db  63
        b      db  0
        d      db  0
        tbl    db  MAX_Z dup(?)

@@2:    mov    ax,  13h
        int    10h
        push   0A000h
        pop    es
        call   setpal
        call   lines
        mov    si,  offset logodata
        mov    di,  61045
        mov    dx,  8
        call   logo
        mov    si,  offset toxilogo
        mov    di,  60485
        mov    dx,  14
        call   logo
        mov    cx,  5
@@4:    call   tables
        call   drawpic
        call   vertret
        mov    ah,  1
        int    16h
        jnz    exit
        inc    cx
        cmp    cx,  MIN_Z
        jb     @@4
        mov    cx,  MIN_Z
@@1:    call   tables
        call   drawpic
        call   fadeout
        call   control
        call   vertret
        mov    ah,  1
        int    16h
        jnz    exit
        inc    cx
        inc    cx
        cmp    cx,  MAX_Z
        jb     @@1
@@3:    call   tables
        call   drawpic
        call   fadein
        call   control
        call   vertret
        mov    ah,  1
        int    16h
        jnz    exit
        dec    cx
        dec    cx
        cmp    cx,  MIN_Z
        ja     @@3
        jmp    @@1

exit:   call   fadeout
        call   vertret
        dec    c
        jnz    exit
        mov    ax,  3
        int    10h
        mov    ah,  9
        lea    dx,  info
        int    21h
        mov    ax,  4C00h
        int    21h

control proc   near
        push   cx
        inc    d
        cmp    d,  6
        jna    @@5
        mov    d,  0
@@5:    mov    si,  offset datelogo
        mov    di,  60640
        mov    dx,  4
        call   logo
        pop    cx
        cmp    b,  0
        jnz    @@1
        dec    c
        dec    c
        jmp    @@2
@@1:    inc    c
        inc    c
@@2:    cmp    c,  30
        jnb    @@3
        mov    b,  1
@@3:    cmp    c,  63
        jna    @@4
        mov    b,  0
@@4:    ret
control endp

setpal  proc   near
        mov    cx,  0FFh
@@1:    mov    ax,  cx
        mov    bx,  4
        mul    bx
        mov    bp,  ax
        mov    dx,  03C8h
        mov    al,  cl
        out    dx,  al
        inc    dx
        mov    al,  data[bp+2]
        shr    al,  2
        out    dx,  al
        mov    al,  data[bp+1]
        shr    al,  2
        out    dx,  al
        mov    al,  data[bp]
        shr    al,  2
        out    dx,  al
        loop   @@1
        ret
setpal  endp

tables  proc   near
        push   cx
        mov    bx,  cx
        xor    dx,  dx
@@1:    mov    ax,  32768
        div    bx
        mul    cx
        shr    ax,  8
        mov    bp,  cx
        mov    tbl[bp],  al
        loop   @@1
        pop    cx
        ret
tables  endp

drawpic proc   near
        push   cx
        cld
        mov    di,  31840
        mov    ax,  cx
        shr    ax,  1
        mov    bx,  ax
        shl    bx,  8
        mov    dx,  ax
        shl    dx,  6
        sub    di,  bx
        sub    di,  dx
        sub    di,  ax
        sub    di,  3200
        mov    dx,  cx
@@1:    push   cx
        mov    bx,  cx
        dec    bx
        mov    bl,  tbl[bx]
        mov    bh,  0
        shl    bx,  7
        mov    cx,  dx
        mov    al,  0
        stosb
@@2:    mov    si,  offset data
        add    si,  1024
        mov    bp,  cx
        dec    bp
        mov    al,  tbl[bp]
        mov    ah,  0
        add    si,  ax
        add    si,  bx
        mov    al,  ds:[si]
        stosb
        loop   @@2
        mov    al,  0
        stosb
        pop    cx
        sub    di,  dx
        add    di,  318
        loop   @@1
        pop    cx
        ret
drawpic endp

vertret proc   near
        mov    dx,  03DAh
@@1:    in     al,  dx
        test   al,  8
        jz     @@1
@@2:    in     al,  dx
        test   al,  8
        jnz    @@2
        ret
vertret endp

fadeout proc   near
        push   cx
        mov    cx,  0FFh
@@1:    call   fadepal
        loop   @@1
        pop    cx
        ret
fadeout endp

fadein  proc   near
        push   cx
        xor    cx,  cx
@@1:    call   fadepal
        inc    cx
        cmp    cx,  256
        jb     @@1
        pop    cx
        ret
fadein  endp

fadepal proc   near
        mov    ax,  cx
        mov    bx,  4
        mul    bx
        mov    bp,  ax
        mov    dx,  03C8h
        mov    al,  cl
        cmp    al,  30
        jne    @@1
        ret
@@1:    cmp    al,  80
        jb     @@2
        cmp    al,  96
        ja     @@2
        ret
@@2:    out    dx,  al
        inc    dx
        mov    al,  data[bp + 2]
        shr    al,  2
        call   fade
        out    dx,  al
        mov    al,  data[bp + 1]
        shr    al,  2
        call   fade
        out    dx,  al
        mov    al,  data[bp]
        shr    al,  2
        call   fade
        out    dx,  al
        ret
fadepal endp

fade    proc   near
        push   dx
        xor    dx,  dx
        mov    bl,  100
        mul    bl
        mov    bl,  63
        div    bl
        mul    c
        mov    bl,  100
        div    bl
        pop    dx
        ret
fade    endp

logo    proc   near
        mov    cx,  5
@@1:    push   cx
        mov    bl,  cl
        mov    cx,  dx
@@2:    push   cx
        lodsb
        mov    cx,  8
@@3:    push   ax
        push   cx
        dec    cl
        shr    al,  cl
        pop    cx
        not    al
        and    al,  1
        add    al,  30
        cmp    al,  31
        jne    @@4
        inc    di
        jmp    @@5
@@4:    cmp    d,  4
        jb     @@6
        mov    al,  86
        add    al,  bl
@@6:    stosb
@@5:    pop    ax
        loop   @@3
        pop    cx
        loop   @@2
        pop    cx
        mov    ax,  dx
        shl    ax,  3
        sub    di,  ax
        add    di,  320
        loop   @@1
        ret
logo    endp

lines   proc   near
        mov    di,  58880
        mov    cx,  16
        mov    al,  96
@@1:    push   cx
        mov    bx,  16
        sub    bx,  cx
        mov    cx,  320
        rep    stosb
        pop    cx
        dec    al
        loop   @@1
        ret
lines   endp

code    ends

        end    @@1